import mysql.simplesql as sql

tables = ['excisemarkwhite']
default_excisetype = 'ALCOHOL'


def insertExciseMarkWhite(excisemarkwhite):
    yield sql.Insert(table='excisemarkwhite', values={
        'excisemarkid': excisemarkwhite.get('excisemarkid', None),
        'excisetype': excisemarkwhite.get('excisetype', default_excisetype),
        'barcode': excisemarkwhite.get('barcode', None),
        'shopcode': excisemarkwhite.get('shopcode', None),
        'inn': excisemarkwhite.get('inn', None),
        'serialnumber': excisemarkwhite.get('serialnumber', None)
    })


def insertExciseMarksWhite(excisemarkswhite):
    for barcode in excisemarkswhite.get('barcodes', []):
        yield sql.Insert(table='excisemarkwhite', values={
            'excisemarkid': excisemarkswhite.get('excisemarkid', None),
            'barcode': barcode,
            'excisetype': excisemarkswhite.get('excisetype', default_excisetype),
            'shopcode': excisemarkswhite.get('shopcode', None),
            'inn': excisemarkswhite.get('inn', None),
            'serialnumber': excisemarkswhite.get('serialnumber', None)
        })


def deleteExciseMarkWhite(excisemarkwhite):
    for i in deleteExciseMarkWhiteById(excisemarkwhite.get('excisemarkid', None),
            excisemarkwhite.get('barcode', None), excisemarkwhite.get('excisetype', default_excisetype)):
        yield i


def deleteExciseMarkWhiteById(excisemarkid, barcode=None, excisetype=default_excisetype):
    if barcode is None:
        yield sql.Delete(table='excisemarkwhite',
                         whereFields=['excisemarkid', 'excisetype'],
                         whereValues=[excisemarkid, excisetype])
    else:
        yield sql.Delete(table='excisemarkwhite',
                         whereFields=['excisemarkid', 'barcode', 'excisetype'],
                         whereValues=[excisemarkid, barcode, excisetype])


def deleteExciseMarksWhite(excisemarkswhite):
    for barcode in excisemarkswhite.get('barcodes', []):
        yield sql.Delete(table='excisemarkwhite',
                whereFields=['excisemarkid', 'barcode', 'excisetype'],
                whereValues=[excisemarkswhite.get('excisemarkid', None), barcode,
                        excisemarkswhite.get('excisetype', default_excisetype)])


def clearExciseMarkWhite():
    yield sql.DeleteAll(table='excisemarkwhite')
